unit uEditarTArco;
  {$MODE Delphi}

interface

uses
  SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ExtCtrls, Buttons,
  uEditarActorConFichas,
  uBaseEditoresActores,
  uBaseEditoresCosasConNombre,
  uSalasDeJuego,
  uCosaConNombre,
  utilidades,
  uOpcionesSimSEEEdit,
  uverdoc,
  uConstantesSimSEE,
  xMatDefs,
  uArcos;

type

  { TEditarTArco }

  TEditarTArco = class(TEditarActorConFichas)
    BAgregarFicha: TButton;
    BAyuda: TButton;
    BCancelar: TButton;
    BEditorDeUnidades: TButton;
    BGuardar: TButton;
    BVerExpandida: TButton;
    cbCondicion_Fuente: TComboBox;
    CBCondicion_NombreBorne: TComboBox;
    CbHidroConEmbalse: TComboBox;
    cbNodoEntrada: TComboBox;
    cbNodoSalida: TComboBox;
    cv_edit: TEdit;
    eNombre: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    LBornePreciosPorCombustible: TLabel;
    LIndicePreciosPorCombustible: TLabel;
    LNodo: TLabel;
    LNodoSalida: TLabel;
    LNombre: TLabel;
    PanelIzquierdo: TPanel;
    Panel2: TPanel;
    PanelDerecho: TPanel;
    Panel4: TPanel;
    sgFichas: TStringGrid;
    procedure cbCondicion_FuenteChange(Sender: TObject);
    procedure CBCondicion_NombreBorneChange(Sender: TObject);
    procedure CbHidroConEmbalseChange(Sender: TObject);
    procedure EditEnter(Sender: TObject);
    procedure EditExit(Sender: TObject);
    procedure cbNodoEntradaChange(Sender: TObject);
    procedure cbNodoSalidaChange(Sender: TObject);
    procedure BEditorDeUnidadesClick(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure BGuardarClick(Sender: TObject); override;
    procedure BAyudaClick(Sender: TObject);
    procedure cbAplicarPerdidasCuadraticasClick(Sender: TObject);
    procedure GroupBox1Click(Sender: TObject);
    procedure GroupBox2Click(Sender: TObject);
    procedure GroupBox3Click(Sender: TObject);
    procedure GroupBox4Click(Sender: TObject);
    procedure LBornePreciosPorCombustibleClick(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
  private
    { Private declarations }
  public
    constructor Create(AOwner: TComponent; sala: TSalaDeJuego;
      tipoCosa: TClass; cosaConNombre: TCosaConNombre); override;
    function validarFormulario: boolean; override;
  end;

implementation

uses SimSEEEditMain;

  {$R *.lfm}

constructor TEditarTArco.Create(AOwner: TComponent; sala: TSalaDeJuego;
  tipoCosa: TClass; cosaConNombre: TCosaConNombre);
var
  actor: TArco;
begin
  inherited Create(AOwner, sala, tipoCosa, cosaConNombre);

  inicializarCBNodosLinkeados(cbNodoEntrada, cbNodoSalida);

  if TSimSEEEditOptions.getInstance.fechasAutomaticas then


  inicializarCBFuente(cbCondicion_Fuente, CBCondicion_NombreBorne, True);
  inicializarCBHidroConEmbalse(CbHidroConEmbalse,true);
  inicializarEditCV(cv_edit);

  if cosaConNombre <> nil then
  begin
    actor := TArco(cosaConNombre);
    inicializarComponentesLPD(actor.lpd, TFichaArco, sgFichas,
      BAgregarFicha, BVerExpandida, BGuardar, BCancelar);

    eNombre.Text := actor.nombre;
    setCBNodoLinkeado(cbNodoEntrada, cbNodoSalida, actor.NodoA, actor.NodoB);

    cv_edit.Text:= FloatToStr(actor.cv_Hidro);
    setCBFuente(cbCondicion_Fuente, CBCondicion_NombreBorne,
      actor.Condicion_Fuente, actor.Condicion_NombreBorne);
    setCBHidroConEmbalse(CbHidroConEmbalse,actor.Condicion_HidroConEmbalse);

    //    cbAplicarPerdidasCuadraticas.Checked:= actor.aplicarPerdidasCuadraticas;
    guardado := True;
  end
  else
    inicializarComponentesLPD(nil, TFichaArco, sgFichas,
      BAgregarFicha, BVerExpandida, BGuardar, BCancelar);
end;

function TEditarTArco.validarFormulario: boolean;
begin
  Result := inherited validarFormulario and inherited  validarNombre(eNombre) and
    inherited validarCBNodoLinkeado(cbNodoEntrada, cbNodoSalida)

end;

procedure TEditarTArco.BAyudaClick(Sender: TObject);
begin
  uverdoc.verdoc( 3828, tipoCosa);
end;

procedure TEditarTArco.BCancelarClick(Sender: TObject);
begin
  inherited BCancelarClick(Sender);
end;

procedure TEditarTArco.BEditorDeUnidadesClick(Sender: TObject);
begin
  inherited BEditorDeUnidadesClick(Sender);
end;

procedure TEditarTArco.BGuardarClick(Sender: TObject);
var
  actor: TArco;
begin
  if validarFormulario then
  begin
    if cosaConNombre = nil then
    begin
      cosaConNombre := TArco.Create(capa, eNombre.Text,
         lpdUnidades, lpd, valorCBNodo(CBNodoEntrada), valorCBNodo(CBNodoSalida){,
                               cbAplicarPerdidasCuadraticas.Checked},
        valorCBFuente(CBCondicion_Fuente), valorCBString(CBCondicion_NombreBorne),
        valorCBHidroConEmbalse(CbHidroConEmbalse),StrToFloat(cv_edit.text), nil, '');
      actor := TArco(cosaConNombre);
    end
    else
    begin
      actor := TArco(cosaConNombre);
      actor.nombre := eNombre.Text;
      actor.lpdUnidades.Free;
      actor.lpdUnidades := lpdUnidades;
      actor.lpd.Free;
      actor.lpd := lpd;
      actor.NodoA := valorCBNodo(cbNodoEntrada);
      actor.NodoB := valorCBNodo(cbNodoSalida);
      //      actor.aplicarPerdidasCuadraticas:= cbAplicarPerdidasCuadraticas.Checked;
      actor.Condicion_fuente := valorCBFuente(CBCondicion_Fuente);
      actor.Condicion_nombreBorne := valorCBString(CBCondicion_NombreBorne);
      actor.Condicion_HidroConEmbalse:=valorCBHidroConEmbalse(CbHidroConEmbalse);
      actor.cv_Hidro:=StrToFloat(cv_edit.text);
    end;
    actor.lpdForzamientos := lpdForzamientos_;
    ModalResult := mrOk;
  end;
end;

procedure TEditarTArco.cbAplicarPerdidasCuadraticasClick(Sender: TObject);
begin
  inherited cambiosForm(Sender);
end;

procedure TEditarTArco.GroupBox1Click(Sender: TObject);
begin

end;

procedure TEditarTArco.GroupBox2Click(Sender: TObject);
begin

end;

procedure TEditarTArco.GroupBox3Click(Sender: TObject);
begin

end;

procedure TEditarTArco.GroupBox4Click(Sender: TObject);
begin

end;

procedure TEditarTArco.LBornePreciosPorCombustibleClick(Sender: TObject);
begin

end;

procedure TEditarTArco.Panel2Click(Sender: TObject);
begin

end;

procedure TEditarTArco.cbNodoEntradaChange(Sender: TObject);
begin
  cbNodoLinkeadoChange(Sender, cbNodoSalida);
end;

procedure TEditarTArco.cbNodoSalidaChange(Sender: TObject);
begin
  cbNodoLinkeadoChange(Sender, cbNodoEntrada);
end;

procedure TEditarTArco.EditEnter(Sender: TObject);
begin
  inherited EditEnter(Sender);
end;

procedure TEditarTArco.cbCondicion_FuenteChange(Sender: TObject);
begin
  inherited CBFuenteChange(Sender, CBCondicion_NombreBorne );
end;

procedure TEditarTArco.CBCondicion_NombreBorneChange(Sender: TObject);
begin
  inherited CBBorneChange(cbCondicion_Fuente, CBCondicion_NombreBorne );
end;

procedure TEditarTArco.CbHidroConEmbalseChange(Sender: TObject);
begin
  inherited cbHidroConEmbalseChange(Sender,true);
end;

procedure TEditarTArco.EditExit(Sender: TObject);
begin
  inherited EditExit(Sender);
end;

procedure TEditarTArco.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  inherited FormCloseQuery(Sender, CanClose);
end;


end.
